<?php

namespace RxConnexionBundle\Controller;

use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\JsonResponse;

use RxConnexionBundle\Entity\AuditTrailEntity;
use RxConnexionBundle\Entity\FinancingCompanyEntity;

use RxConnexionBundle\Form\FinancingCompanyForm;

/**
 * @Route("/main/financing_company")
 */
class FinancingCompanyController extends Controller
{
    /**
     * @Route("", name="financing_company")
     */
    public function indexAction() {

        $authService = $this->get('rx_connexion.authService');
        if(!$authService->isLoggedIn()) return $authService->redirectToLogin();
        if(!$authService->isUserHasAccesses(array('Admin Financing Company'))) return $authService->redirectToHome();

        return $this->render('@RxConnexion/FinancingCompany/index.html.twig', array(
            'title' => 'Manage Financing Company',
            'page_title' => 'Manage Financing Company',
            'javascripts' => array('rxconnexion/admin/js/financingCompany/financingCompany.js?v=1.0.0')
        ));
    }

    /**
     * @Route("/ajax_list", name="financing_company_ajax_list")
     */
    public function ajax_list(Request $request) {

        $get = $request->query->all();

        $result = array(
            "draw" => intval($get['draw']),
            "recordsTotal" => 0,
            "recordsFiltered" => 0,
            "data" => array()
        );

        $authService = $this->get('rx_connexion.authService');
        if($authService->isLoggedIn()) {

            $hasUpdate = $authService->isUserHasAccesses(array('Admin Financing Company Update'), false);

            $data = $this->getDoctrine()->getManager()->getRepository('RxConnexionBundle:FinancingCompanyEntity')->ajax_list($get, $this->get('session')->get('userData'));

            foreach($data['results'] as $row) {

                $id = base64_encode($row['id']);
                $action = '';

                if($hasUpdate) {
                    $url = $this->generateUrl('financing_company_form', array(
                        'action' => 'u',
                        'id' => $id
                    ));
                    $action = "<a class='action-button-style' href='$url'>Update</a>";
                }

                $values = array(
                    $row['code'],
                    $row['description'],
                    $row['address'],
                    $row['mobileNos'],
                    $row['phoneNos'],
                    $row['faxNos'],
                    $row['emails'],
                    $action
                );

                $result['data'][] = $values;
            }

            $result['recordsTotal'] = $data['total'];
            $result['recordsFiltered'] = $data['total'];
        }

        return new JsonResponse($result);
    }

    /**
     * @Route(
     *      "/form/{action}/{id}",
     *      defaults = {
     *          "action":  "n",
     *          "id": 0
     *      },
     *      requirements = {
     *          "action": "n|u"
     *      },
     *      name = "financing_company_form"
     * )
     */
    public function formAction($action, $id, Request $request) {

        $authService = $this->get('rx_connexion.authService');
        if(!$authService->isLoggedIn()) return $authService->redirectToLogin();
        if(!$authService->isUserHasAccesses(array('Admin Financing Company New', 'Admin Financing Company Update'))) return $authService->redirectToHome();

        $em = $this->getDoctrine()->getManager();

        $financingCompany = $em->getRepository('RxConnexionBundle:FinancingCompanyEntity')->find(base64_decode($id));
        if(!$financingCompany) {
            $financingCompany = new FinancingCompanyEntity();
        }

        $formOptions = array('action' => $action);
        $form = $this->createForm(FinancingCompanyForm::class, $financingCompany, $formOptions);

        if($request->getMethod() === 'POST') {

            $financingCompany_form = $request->get($form->getName());
            $result = $this->processForm($financingCompany_form, $financingCompany, $form, $request);

            if($result['success']) {
                if($result['redirect'] === 'index') {
                    return $this->redirect($this->generateUrl('financing_company'), 302);
                } else if($result['redirect'] === 'form') {
                    return $this->redirect($this->generateUrl('financing_company_form', array(
                        'action' => 'u',
                        'id' => base64_encode($result['id'])
                    )), 302);
                } else if($result['redirect'] === 'form with error') {
                    return $this->redirect($this->generateUrl('financing_company_form'), 302);
                }
            } else {
                $form->submit($financingCompany_form, false);
            }
        }

        $title = ($action === 'n' ? 'New' : 'Update') . ' Financing Company';

        return $this->render('@RxConnexion/FinancingCompany/form.html.twig', array(
            'title' => $title,
            'page_title' => $title,
            'javascripts' => array('rxconnexion/admin/js/financingCompany/financingCompany_form.js?v=1.0.0'),
            'form' => $form->createView(),
            'action' => $action,
            'id' => $id
        ));
    }

    private function processForm($financingCompany_form, $financingCompany, $form, Request $request) {

        $em = $this->getDoctrine()->getManager();

        $errors = $em->getRepository('RxConnexionBundle:FinancingCompanyEntity')->validate($financingCompany_form);

        if(!count($errors)) {

            switch($financingCompany_form['action']) {

                case 'n': // new

                    $form->handleRequest($request);

                    if ($form->isValid()) {

                        $em->persist($financingCompany);
                        $em->flush();

                        if(isset($_FILES['form']) && !empty($_FILES['form']['tmp_name']['photo'])) {

                            $baseName = $financingCompany->getId() . '-' . time() . '.' . pathinfo($_FILES['form']['name']['photo'], PATHINFO_EXTENSION);
                            $uploadFile = $financingCompany->getUploadRootDir() . '/' . $baseName;

                            if (move_uploaded_file($_FILES['form']['tmp_name']['photo'], $uploadFile)) {
                                $financingCompany->removePhoto();
                                $financingCompany->setPhotoDesc($_FILES['form']['name']['photo']);
                                $financingCompany->setParsedPhotoDesc($baseName);
                                $em->flush();

                            }
                        }

                        $newAT = new AuditTrailEntity(
                            'Financing Company',
                            $em->getClassMetadata(FinancingCompanyEntity::class)->getTableName(),
                            AuditTrailEntity::AXN_NEW
                        );
                        $newAT->entity = $financingCompany;
                        $newAT->parseDetails();
                        $em->persist($newAT);
                        $em->flush();

                        $this->get('session')->getFlashBag()->set('success_messages', 'Record Successfully Saved.');

                        $result['redirect'] = 'index';

                    } else {

                        $this->get('session')->getFlashBag()->set('error_messages', 'Something went wrong. Please try again.');
                        $result['redirect'] = 'form with error';
                    }

                    break;

                case 'u': // update

                    $newAT = new AuditTrailEntity(
                        'Financing Company',
                        $em->getClassMetadata(FinancingCompanyEntity::class)->getTableName(),
                        AuditTrailEntity::AXN_UPDATE
                    );
                    $newAT->entity = $financingCompany;
                    $newAT->parseOriginalDetails();

                    $form->handleRequest($request);

                    if ($form->isValid()) {

                        $newAT->entity = $financingCompany;
                        $newAT->parseDetails();

                        $em->flush();
                        if(isset($_FILES['form']) && !empty($_FILES['form']['tmp_name']['photo'])) {

                            $baseName = $financingCompany->getId() . '-' . time() . '.' . pathinfo($_FILES['form']['name']['photo'], PATHINFO_EXTENSION);
                            $uploadFile = $financingCompany->getUploadRootDir() . '/' . $baseName;

                            if (move_uploaded_file($_FILES['form']['tmp_name']['photo'], $uploadFile)) {
                                $financingCompany->removePhoto();
                                $financingCompany->setPhotoDesc($_FILES['form']['name']['photo']);
                                $financingCompany->setParsedPhotoDesc($baseName);
                                $em->flush();

                            }
                        }

                        $this->get('session')->getFlashBag()->set('success_messages', 'Record Successfully Updated.');

                        $result['redirect'] = 'index';

                    } else {

                        $this->get('session')->getFlashBag()->set('error_messages', 'Something went wrong. Please try again.');
                        $result['redirect'] = 'form with error';
                    }

                    break;

                case 'd': // delete

                    $newAT = new AuditTrailEntity(
                        'Financing Company',
                        $em->getClassMetadata(FinancingCompanyEntity::class)->getTableName(),
                        AuditTrailEntity::AXN_DELETE
                    );
                    $newAT->entity = $financingCompany;
                    $newAT->parseDetails();
                    $em->persist($newAT);

                    $form->handleRequest($request);

                    if ($form->isValid()) {

                        //$em->remove($financingCompany);
                        $financingCompany->setIsDeleted(true);

                        $em->flush();

                        $this->get('session')->getFlashBag()->set('success_messages', 'Record Successfully Deleted.');

                        $result['redirect'] = 'index';

                    } else {

                        $this->get('session')->getFlashBag()->set('error_messages', 'Something went wrong. Please try again.');
                        $result['redirect'] = 'form with error';
                    }

                    break;
            }

            $result['success'] = true;

        } else {

            foreach($errors as $error) {
                $this->get('session')->getFlashBag()->add('error_messages', $error);
            }

            $result['success'] = false;
        }

        return $result;
    }

    /**
     * @Route("/autocomplete", name="financing_company_autocomplete")
     */
    public function autocompleteAction(Request $request) {

        $q = $request->get('query');

        $result = array(
            'query' => 'cities',
            'suggestions' => $this->getDoctrine()->getManager()->getRepository('RxConnexionBundle:FinancingCompanyEntity')->autocomplete_suggestions($q)
        );

        return new JsonResponse($result);
    }
}
